/*->h.csview */




// screen views use these bits for processvalue


#define COLMASK   0xFFFFFF
#define SPOTSHIFT 30
#define SPOTMASK  (1<<SPOTSHIFT)

// printer views use these bits for processvalue

#define PLATEMASK   0xFFFF
#define COPYSEP     0x10000
#define COPYNOBLACK 0x20000

// common screen and print bits

#define COLDEFPROCESS 0x80000000




#define MAXTINT2 (MAXTINT>>2)



extern char cstab16[32];


extern os_error * colseprgb2hsv(filestr * file,quadstr * rgb,quadstr * hsv);
extern os_error * colsephsv2rgb(filestr * file,quadstr * hsv,quadstr * rgb);
extern os_error * colseprgb2cmyk(filestr * file,quadstr * rgb,quadstr * cmyk);
extern os_error * colsepcmyk2rgb(filestr * file,quadstr * cmyk,quadstr * rgb);


extern os_error * xcolseprgb2hsv(viewstr * view,filestr * file,
                                          quadstr * rgb,quadstr * hsv);
extern os_error * xcolsephsv2rgb(viewstr * view,filestr * file,
                                          quadstr * hsv,quadstr * rgb);
extern os_error * xcolseprgb2cmyk(viewstr * view,filestr * file,
                                              quadstr * rgb,quadstr * cmyk);
extern os_error * xcolsepcmyk2rgb(viewstr * view,filestr * file,
                                            quadstr * cmyk,quadstr * rgb);


extern os_error * xcolsepcmyk2rgb3232(viewstr * view,int * s,int * d,int size);
extern os_error * colsepcmyk2rgb3232(int * s,int * d,int size);

extern os_error * colsepcmyk2bgr3232(int * s,int * d,int size);
extern os_error * xcolsepcmyk2bgr3232(viewstr * view,int * s,int * d,int size);

extern os_error * colseprgb2cmyk3232(int * s,int * d,int size);
extern os_error * colseprgb2cmykpal32(int * s,int * d,int size);
extern os_error * colsepcmyk2rgb32pal(int * s,int * d,int size);
extern os_error * colseprgb2cmyk1632(int * s,int * d,int size);
extern os_error * colsepcmyk2rgb3216(int * s,int * d,int size);

extern os_error * colsepprocess(viewstr * view,void * d,void * s,int size,
                                                      int dtype,int stype);



extern int csviewbits(int fp);

extern int csreadfrequency(int fp);
extern int csreadangle(int fp);
extern int csreadpsscreen(int fp);
extern int csreadspot(int fp);
extern int csreadseps(int fp);
extern int csreadcolour(int fp);

extern int csreadpxfrequency(int fp);
extern int csreadpxangle(int fp);
extern int csreadpxpsscreen(int fp);
extern int csreadpxspot(int fp);


extern int currentcolour;
extern int currentspot;


extern os_error * colsepprint(void * prjob,int code);
extern os_error * colseppict(viewredrawstr * v,int pict,int process,int code);
extern int        colsepcurrentplate(void * prjob);


extern os_error * csviewevent(int eventn,int userhandle,
                                         filestr * file,int data1);

extern os_error * csviewevent2(int eventn,int userhandle,
                                         filestr * file,int data1);



extern os_error * csnewviewevent(int eventn,int userhandle,
                                         viewstr * file,int data1);

extern os_error * csnewcolourmodel(int eventn,int userhandle,
                                         void * data,int data1);
