
/* ->c.grab */
/* Grabber hand code*/


#include "stdafx.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h> 

#include "os.h"
#include "bbc.h"
#include "sprite.h"
#include "wimp.h"

#include "transform.h"

#include "xprocess.h"



#include "wos.h"
#include "poll.h"
#include "etc.h"
#include "fsx.h"
#include "bf.h"
#include "flex.h"
#include "sp.h"
#include "task.h"
#include "xhelp.h"
#include "trans.h"
#include "deb.h"
#include "dbhi.h"


#include "constants.h"
#include "str.h"


#include "file.h"
#include "view.h"
#include "viewo.h"


#include "toolstr.h"
#include "tools.h"
#include "mhi.h"







static HANDLE modulehandle;


static pointstr grabptr=
{
 "p_hand",0,0
};



static int       dragstate;
static int       startx;
static int       starty;
static viewstr * cview;



static os_error * cmenu(toolboxstr * toolbox,viewstr * view,
                                             filestr * file,wimp_mousestr * m)
{
 return(openmenu("main_menu"));
 USE(view);
 USE(file);
 USE(m);
 USE(toolbox);
}



static os_error * ckey(toolboxstr * toolbox,int * key,fkeyfn * fk)
{
 menukey(key);
 if(*key==-1) *fk=menukey;
 return(NULL);
 USE(toolbox);
}





static os_error * cclick(toolboxstr * toolbox,posnstr * posn)
{
 os_error     * err;

 err=NULL;

 if(posn->buttons==VBDRAGS)
 {
  toolsstartdrag(posn,TOOLDRAGPTR|TOOLDRAGSCREEN|TOOLDRAGNS);
  dragstate=1;
  startx=posn->mousex;
  starty=posn->mousey;
  cview=posn->view;
 }

 return(err);

 USE(toolbox);
}


static os_error * cmove(toolboxstr * toolbox,posnstr * posn,int move)
{

 if(dragstate && move)
 {
  viewopenshift(cview,startx-posn->mousex,starty-posn->mousey);
  startx=posn->mousex;
  starty=posn->mousey;
 }


 return(NULL);

 USE(toolbox);
 USE(posn);
}





static os_error * cdragend(toolboxstr * toolbox,
                               posnstr * posn,wimp_box * box)
{
 dragstate=0;
 return(NULL);

 USE(box);
 USE(posn);
 USE(toolbox);
}



static os_error * ccancel(toolboxstr * toolbox,viewstr * view,
                                                   filestr * file)
{
 dragstate=0;
 return(NULL);

 USE(toolbox);
 USE(view);
 USE(file);
}



static os_error * ciprefresh(viewstr * view,int handle,int code)
{

 if(code==-1) 
 {
  writeiconf(view->info,IP_HELPI,"%s","{GRB00}");
 }

 return(NULL);
 USE(view);
}



static ipstr cipstr=
{
 NULL,           /* click    */
 NULL,           /* key      */
 NULL,           /* icon map */
 0,              /* template */
 0,              /* code     */
 ciprefresh,     /* refresh  */
};




static os_error * cselect(toolboxstr * toolbox,viewstr * view,
                                                   filestr * file,int select)
{

 ipchangepane(toolbox,IP_PANE1,select?&cipstr:NULL);

 return(NULL);

 USE(toolbox);
 USE(view);
 USE(file);
}




static os_error * cptr(toolboxstr * toolbox,posnstr * posn)
{
 toolschangepointer(0,USERPOINTER,&grabptr);

 return(NULL);

 USE(toolbox);
 USE(posn);
}






static toolstr grab=
{
 TL_GRAB,
 "grabber",
 "t_grabber\0t_pgrabber",
 "{GRATIP}",
 1,
 cclick,
 cmove,
 cselect,
 cptr,
 ccancel,
 NULL,
 cdragend,
 cmenu,
 ckey,
 NULL,
 NULL,
 NULL,

 0,

 0,       /*  preselect */
 0,       /*  noicon    */
 0,       /*  spare2    */
 0,       /*  spare3    */
 0,       /*  spare4    */ 
 0,       /*  spare5    */
 0,       /*  spare6    */
 0,       /*  spare7    */


 TPOINTER,
 0,
 0,
 100,     /*  rank      */
};




static char * grabpath;


static os_error * spriteevent(int eventn,int userhandle,void * data,int data1)
{

 cprintf("||||||||||||||||||grabber event");
 
 remevent(EVENT_LOADSPRITES,spriteevent,0);
 return(addspritesx(grabpath,"Grabber\\Resources\\Sprites.spr"));

 USE(eventn);
 USE(userhandle);
 USE(data);
 USE(data1);
}



static os_error * messevent(int eventn,int userhandle,void * data,int data1)
{
 remevent(EVENT_LOADMESSAGES,messevent,0);
 return(addtranstable(grabpath,"Grabber\\Resources\\Messages.txt"));

 USE(eventn);
 USE(userhandle);
 USE(data);
 USE(data1);
}



static os_error * helpevent(int eventn,int userhandle,void * data,int data1)
{
 remevent(EVENT_LOADHELP,helpevent,0);
 return(addhelp(grabpath,"Grabber\\Resources\\Help.txt"));

 USE(eventn);
 USE(userhandle);
 USE(data);
 USE(data1);
}




static os_error * docevent1(int eventn,int userhandle,void * data,int data1)
{
 cprintf("||||||||||||||||||doc1 event");
 remevent(EVENT_DOCINIT1,docevent1,0);
 return(toolregister(&grab));

 USE(eventn);
 USE(userhandle);
 USE(data);
 USE(data1);
}




extern "C" __declspec(dllexport) os_error * entrypoint(char * path)
{ 
 os_error * err;

 grabpath=path;

 cprintf("grabber entry xxxxxxxxxxxxxxxxxxxx");

          err=addevent(EVENT_LOADSPRITES,spriteevent,0);
 if(!err) err=addevent(EVENT_DOCINIT1,docevent1,0);
 if(!err) err=addevent(EVENT_LOADMESSAGES,messevent,0);
 if(!err) err=addevent(EVENT_LOADHELP,helpevent,0);

 return(err);
}




extern "C" BOOL __stdcall _DllMainCRTStartup( 
    HINSTANCE hinstDLL,     // handle to DLL module 
    DWORD fdwReason,        // reason for calling function 
    LPVOID lpvReserved)     // reserved 
{
 
 modulehandle=(HMODULE)hinstDLL;
 return(TRUE);
}
