//->!EPSCode





void eps_supplied(int user,int view)
{
 prprints("%%+ procset DPL_EPS_Support 1.00 0\r\n");
 prprints("%%+ procset DPL_EPS_Separations 1.00 0\r\n");
}



void eps_defs(void)
{
 prprints("%%BeginResource: procset DPL_EPS_Support 1.00 0\r\n"); // ref. above
 prprints("%%Title: OvationPro EPS applet functions\r\n");
 prprints("%%CreationDate: 30/11/2003\r\n");
 prprints("%%Copyright: (C) 2003 David Pilling Ltd All Rights Reserved\r\n");

 prprints("/BeginEPSF { %def\r\n");
 prprints("/b4_inc_state save def\r\n");
 prprints("/dict_count countdictstack def\r\n");
 prprints("/op_count count 1 sub def\r\n");
 prprints("userdict begin\r\n");
 prprints("/showpage { } def\r\n");
 prprints("0 setgray 0 setlinecap\r\n");
 prprints("1 setlinewidth 0 setlinejoin\r\n");
 prprints("10 setmiterlimit [ ] 0 setdash newpath\r\n");
 prprints("/languagelevel where\r\n");
 prprints("{pop languagelevel\r\n");
 prprints("1 ne\r\n");
 prprints("{false setstrokeadjust false setoverprint\r\n");
 prprints("} if\r\n");
 prprints("} if\r\n");
 prprints("} bind def\r\n");

 prprints("/EndEPSF { %def\r\n");
 prprints("count op_count sub { pop } repeat\r\n");
 prprints("countdictstack dict_count sub { end } repeat\r\n");
 prprints("b4_inc_state restore\r\n");
 prprints("} bind def\r\n");

 prprints("%%EndResource\r\n\r\n");


}




void eps_sepdefs(void)
{

 prprints("%%BeginResource: procset DPL_EPS_Separations 1.00 0\r\n");  // ref. above
 prprints("%%Title: OvationPro EPS applet separations dictionary\r\n");
 prprints("%%CreationDate: 30/11/2003\r\n");
 prprints("%%Copyright: (C) 2003 David Pilling Ltd All Rights Reserved\r\n");


 prprints("/OPEPSdict 40 dict def\r\n");
 prprints("OPEPSdict begin\r\n");

 prprints("/opcyan 7 def\r\n");
 prprints("/opyellow 9 def\r\n");
 prprints("/opmagenta 8 def\r\n");
 prprints("/opblack 1 def\r\n");
 prprints("/opsep opblack def\r\n");

 prprints("/setgray {opsep opblack eq\r\n");
 prprints("{systemdict begin setgray end}\r\n");
 prprints("{pop systemdict begin 1 setgray end}\r\n");
 prprints("ifelse }def\r\n");

 prprints("/setcmykcolor {opsep opblack eq\r\n");
 prprints("{systemdict begin 1 exch sub setgray end pop pop pop }\r\n");
 prprints("{pop opsep opyellow eq {systemdict begin 1 exch sub setgray end pop pop }\r\n");
 prprints("{pop opsep opmagenta eq {systemdict begin 1 exch sub setgray end pop }\r\n");
 prprints("{pop opsep opcyan eq {systemdict begin 1 exch sub setgray end }\r\n");
 prprints("if}\r\n");
 prprints("ifelse}\r\n");
 prprints("ifelse}\r\n");
 prprints("ifelse}\r\n");
 prprints("bind def\r\n");

 prprints("/setrgbcolor {systemdict begin setrgbcolor currentcmykcolor end userdict begin setcmykcolor end} def\r\n");

 prprints("/sethsbcolor{systemdict begin sethsbcolor\r\n");
 prprints("currentrgbcolor end userdict begin setrgbcolor end}def\r\n");

 prprints("end\r\n");

 prprints("%%EndResource\r\n\r\n");
}








void eps_prerender(int a,int b,int c,int d,int e,int f,string & name,int sep)
{
 if(sep) 
 {
  prprints("OPEPSdict begin\r\n");
  prprints("/opsep "+itos(sep)+" store\r\n");
 }

 prprints("%%BeginDocument: "+name+"\r\n");
 prprints("BeginEPSF\r\n");

 prprints("["+dpstring(a,4)+" "+dpstring(b,4)+" "+dpstring(c,4)+" "+dpstring(d,4)+" "+itos(scale(e,400,256))+" "+itos(scale(f,400,256))+"] concat\r\n");

 prprints("[ 1000 0 0 1000 0 0] concat\r\n");

}


void eps_postrender(int sep)
{
 
 prprints("EndEPSF\r\n");
 prprints("%%EndDocument\r\n");

 if(sep) prprints("end\r\n");
}








// return 0 on success
// used to convert the embedded preview image into a sprite
// ftype can be TIFF or Windows Meta file

int eps_convert(string & from,int ftype,string & to)
{

 switch(ftype)
 {
  case 0xFF0:
			 return(transload(from,ftype,to,0xAFF));
             break;
 }

 return(1);
}



void eps_prolog1event(int user,int view)
{
 eps_defs();
 eps_sepdefs();
}



void main(void)
{
 addeventhandler(0x513,0,"eps_prolog1event");
 addeventhandler(0x521,0,"eps_supplied");
}
